#ifndef _MAIN_H__
#define _MAIN_H__


// If debug is defined we will compile uart functions.
// Choose at least 1 MHz Clock and not more than 1200 Baud/s.
//#define DEBUG_UART
#define DEBUG_UARD_DATA_INTERVAL    2 // [s]

// ATTENTION: Comment this calibration line before real use!
//            Otherwise there will be no overcharge protection!
//#define CALIBRATION_MODE
#ifdef CALIBRATION_MODE
    #ifndef DEBUG_UART
        #error "You need the uart to calibrate."
    #endif
#endif


#define ADC_OVERSAMPLING        16  // max 64! (4 times increases resolution by one bit, 16x 2 bit, 64x 3 bit)
#define ADC_OVERSAMPLING_DIV    4   // 2 for 4x oversampling, 4 for 16x, 8 for 64x
#define VOLTAGE_ADC_TOP             (1024 * ADC_OVERSAMPLING / ADC_OVERSAMPLING_DIV - 1) // set for 10 Bit ADC

#define BATT_MAX_VOLTAGE            13800 // [mV]
#define BATT_RECHARGE               13600 // [mV]
#define BATT_MIN_VOLTAGE            10800 // [mV]
#define BATT_RECONNECT_LOAD         11500 // [mV]

// If the battery voltage is above these values choose the apropriate led-color
#define LED_VOLTAGE_HIGH            12200 // [mV]
#define LED_VOLTAGE_MEDIUM          11900 // [mV]
#define LED_VOLTAGE_HYSTERESIS      40 // [mV]

#define LED_CHARGE_THRESHOLD        250 // [mV] panel voltages has to be at leat this much higher than battery voltage
#define LED_CHARGE_HYSTERESIS       30  // [mV]

#endif

