#include "uart.h"
#include "main.h"
#include <avr/io.h>

#ifdef DEBUG_UART

void uart_init(void)
{
    // UCSRnA – USART Control and Status Register n A
    // TODO
    
    // UCSRnB – USART Control and Status Register n B
    UCSR0B |= 1 << RXEN0 | 1 << TXEN0;

    // UCSRnC – USART Control and Status Register n C
    UCSR0C = /*1 << URSEL0 |*/ 1 << UCSZ01 | 1 << UCSZ00; // Asynchron 8N1 
    
    // UBRRnL and UBRRnH – USART Baud Rate Registers
    UBRR0 = UART_UBRR_VAL;
}


void uart_putc(char c)
{
    // wait until transmission possible
    while (!(UCSR0A & (1 << UDRE0))) {}
    UDR0 = c;
}
 

void uart_puts(char *s)
{
    // send until we hit a '\0'
    while (*s)
    {
        uart_putc(*s);
        s++;
    }
}

#endif

