#ifndef _UART_H__
#define _UART_H__

#include <stdint.h>
#include <avr/io.h>
#include "main.h"

#ifdef DEBUG_UART

// from http://www.mikrocontroller.net/articles/AVR-GCC-Tutorial/Der_UART
#define UART_BAUD       1200
#define UART_UBRR_VAL   ((F_CPU + UART_BAUD * 8) / (UART_BAUD * 16) - 1)  // clever runden
#define UART_BAUD_REAL  (F_CPU / (16 * (UART_UBRR_VAL + 1)))    // Reale Baudrate
#define UART_BAUD_ERROR ((UART_BAUD_REAL * 1000) / UART_BAUD)   // Fehler in Promille, 1000 = kein Fehler.
#if ((UART_BAUD_ERROR < 990) || (UART_BAUD_ERROR > 1010))
    #error "Baudrate error is greater than 1 percent!"
#endif 

void uart_init(void);
void uart_putc(char);
void uart_puts(char *);
void uart_puts_power_enable(char *s);
void uart_puts_power_enable_disable(char *s);
void uart_puts_power_disable(char *s);


#endif // DEBUG_UART

#endif

